package mycustommodule;

import org.openide.awt.*;
import star.common.StarScript;
import star.coremodule.actions.SimulationAction;
import star.locale.annotation.StarAction;

// Apply action annotations
@StarAction(display = "Hello World", hint = "Displays Hello World Message")
@ActionID(id = "mycustommodule.MyAction", category = "MyModule")
@ActionRegistration(displayName = "Hello World", lazy = false)
@ActionReferences(value = {
    @ActionReference(path = "Toolbars/HelloWorld", position = 1),
    @ActionReference(path = "Shortcuts", name = "D-Q"),
    @ActionReference(path = "Menu/MyModule", position = 1)})

// Extend the SimulationAction class
public class MyAction extends SimulationAction {
    private static final String ICON = "mycustommodule/icons/helloworld.png";
    @Override
    protected String iconResource() {
        return ICON;
    }
    @Override
    public void performAction() {
        // Create a separate thread
        Thread t = new Thread(new Runnable() {
            @Override
            public void run() {

                // Run macro as StarScript
                StarScript sc = new StarScript(getSimulationProcessObject().getSimulation(), new HelloWorld());
                sc.play();
            }
        });
        t.start();
    }
}